namespace CodeSnippet.Config
{
    /// <summary>
    /// Interface defining the properties used in the editor logic.
    /// </summary>
    public interface IEditorConfig
    {
        #region Properties
        /// <summary>
        /// Number of space characters to substitute for tab characters.
        /// </summary>
        byte TabSpaces { get; set; }
        /// <summary>
        /// Flag indicating whether or not to trim TAB characters from the beginning of lines when being pasted.
        /// </summary>
        bool TrimIndentOnPaste { get; set; }
        /// <summary>
        /// Flag indicating whether word-wrapping is enabled in the view.
        /// </summary>
        bool WordWrap { get; set; }
        #endregion Properties
    }
}