namespace CodeSnippet.Formats
{
    /// <summary>
    /// Generates color-coded HTML 4.01 from Java source code.
    /// </summary>
    public class JavaFormat : CLikeFormat
    {
        #region Properties
        /// <summary>
        /// The list of Java keywords.
        /// </summary>
        protected override string Keywords
        {
            get
            {
                return "abstract assert boolean break byte case catch char "
                       + "class const continue default do double else enum extends "
                       + "final finally float for goto if implements import instanceof "
                       + "int interface long native new package private protected public "
                       + "return short static strictfp super switch synchronized this "
                       + "throw throws transient try void volatile while";
            }
        }
        /// <summary>
        /// The list of Java preprocessors.
        /// </summary>
        protected override string Preprocessors
        {
            get
            {
                return "";
            }
        }
        #endregion Properties
    }
}
