﻿namespace CodeSnippet.Forms
{
    /// <summary>
    /// Indicates the plugin form to display.
    /// </summary>
    public enum CodeSnippetViewMode
    {
        Compact,
        Full
    }
    /// <summary>
    /// Indicates the panel to display when in Full view mode.
    /// </summary>
    /// <remarks>
    /// <para>Following is a brief description of the meaning of these values:</para>
    /// <list type="bullet">
    /// <item>
    /// <description><c>CodeSnippet</c>&nbsp;-&nbsp;Displays the window containing the source code.</description>
    /// </item>
    /// <item>
    /// <description><c>FormattedCodeSnippet</c>&nbsp;-&nbsp;Displays the window containing the HTML preview of the formatted source code.</description>
    /// </item>
    /// <item>
    /// <description><c>Both</c>&nbsp;-&nbsp;Displays both the source code and the HTML preview of the formatted source code.</description>
    /// </item>
    /// </list>
    /// </remarks>
    public enum CodeSnippetViewType
    {
        CodeSnippet,
        FormattedCodeSnippet,
        Both
    }
}
